%bcond_with check

%global gomodulesmode   GO111MODULE=on
%global dracutlibdir %{_prefix}/lib/dracut

Summary:        First boot installer and configuration tool
Name:           ignition
Version:        2.21.0
Release:        1%{?dist}
License:        ASL 2.0
URL:            https://github.com/coreos/ignition
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires:  libblkid-devel systemd-rpm-macros go-rpm-macros
Requires: dosfstools gdisk dracut dracut-network

# https://github.com/coreos/ignition/pull/2051
# https://github.com/golang/oauth2/commit/ce56909505b351a755ad0bc294c5ee01ed0ea050
# https://github.com/coreos/ignition/commit/4af32b2d739c5b25c1332482ce4f03fd900bc72f
Patch0001: fix-CVE-2025-22868.patch

# Generated by `go-mods-to-bundled-provides.py | sort`
Provides: bundled(golang(cloud.google.com/go/compute/metadata)) = 0.6.0
Provides: bundled(golang(cloud.google.com/go/storage)) = 1.50.0
Provides: bundled(golang(cloud.google.com/go/storage/experimental)) = 1.50.0
Provides: bundled(golang(cloud.google.com/go/storage/internal)) = 1.50.0
Provides: bundled(golang(cloud.google.com/go/storage/internal/apiv2)) = 1.50.0
Provides: bundled(golang(cloud.google.com/go/storage/internal/apiv2/storagepb)) = 1.50.0
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/azidentity)) = 1.8.2
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/azidentity/internal)) = 1.8.2
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/storage/azblob)) = 1.6.0
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/storage/azblob/appendblob)) = 1.6.0
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/storage/azblob/blob)) = 1.6.0
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/storage/azblob/bloberror)) = 1.6.0
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/storage/azblob/blockblob)) = 1.6.0
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/storage/azblob/container)) = 1.6.0
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/storage/azblob/internal/base)) = 1.6.0
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/storage/azblob/internal/exported)) = 1.6.0
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/storage/azblob/internal/generated)) = 1.6.0
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/storage/azblob/internal/shared)) = 1.6.0
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/storage/azblob/pageblob)) = 1.6.0
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/storage/azblob/sas)) = 1.6.0
Provides: bundled(golang(github.com/Azure/azure-sdk-for-go/sdk/storage/azblob/service)) = 1.6.0
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/arn)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/auth/bearer)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/awserr)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/awsutil)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/client)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/client/metadata)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/corehandlers)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/credentials)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/credentials/ec2rolecreds)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/credentials/endpointcreds)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/credentials/processcreds)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/credentials/ssocreds)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/credentials/stscreds)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/csm)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/defaults)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/ec2metadata)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/endpoints)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/request)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/session)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/aws/signer/v4)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/internal/context)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/internal/ini)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/internal/s3shared)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/internal/s3shared/arn)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/internal/s3shared/s3err)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/internal/sdkio)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/internal/sdkmath)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/internal/sdkrand)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/internal/sdkuri)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/internal/shareddefaults)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/internal/strings)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/internal/sync/singleflight)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/private/checksum)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/private/protocol)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/private/protocol/eventstream)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/private/protocol/eventstream/eventstreamapi)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/private/protocol/json/jsonutil)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/private/protocol/jsonrpc)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/private/protocol/query)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/private/protocol/query/queryutil)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/private/protocol/rest)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/private/protocol/restjson)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/private/protocol/restxml)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/private/protocol/xml/xmlutil)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/service/s3)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/service/s3/s3iface)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/service/s3/s3manager)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/service/sso)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/service/sso/ssoiface)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/service/ssooidc)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/service/sts)) = 1.55.6
Provides: bundled(golang(github.com/aws/aws-sdk-go/service/sts/stsiface)) = 1.55.6
Provides: bundled(golang(github.com/beevik/etree)) = 1.5.0
Provides: bundled(golang(github.com/containers/libhvee/pkg/kvp)) = 0.10.0
Provides: bundled(golang(github.com/coreos/go-semver/semver)) = 0.3.1
Provides: bundled(golang(github.com/coreos/go-systemd/v22/dbus)) = 22.5.0
Provides: bundled(golang(github.com/coreos/go-systemd/v22/journal)) = 22.5.0
Provides: bundled(golang(github.com/coreos/go-systemd/v22/unit)) = 22.5.0
Provides: bundled(golang(github.com/coreos/vcontext/json)) = 0.0.0-20230201181013.gitd72178a18687
Provides: bundled(golang(github.com/coreos/vcontext/path)) = 0.0.0-20230201181013.gitd72178a18687
Provides: bundled(golang(github.com/coreos/vcontext/report)) = 0.0.0-20230201181013.gitd72178a18687
Provides: bundled(golang(github.com/coreos/vcontext/tree)) = 0.0.0-20230201181013.gitd72178a18687
Provides: bundled(golang(github.com/coreos/vcontext/validate)) = 0.0.0-20230201181013.gitd72178a18687
Provides: bundled(golang(github.com/google/renameio/v2)) = 2.0.0
Provides: bundled(golang(github.com/google/uuid)) = 1.6.0
Provides: bundled(golang(github.com/mdlayher/vsock)) = 1.2.1
Provides: bundled(golang(github.com/mitchellh/copystructure)) = 1.2.0
Provides: bundled(golang(github.com/pin/tftp)) = 2.1.0
Provides: bundled(golang(github.com/pin/tftp/netascii)) = 2.1.0
Provides: bundled(golang(github.com/spf13/pflag)) = 1.0.6
Provides: bundled(golang(github.com/stretchr/testify/assert)) = 1.10.0
Provides: bundled(golang(github.com/stretchr/testify/assert/yaml)) = 1.10.0
Provides: bundled(golang(github.com/vincent-petithory/dataurl)) = 1.0.0
Provides: bundled(golang(github.com/vmware/vmw-guestinfo/bdoor)) = 0.0.0-20220317130741.git510905f0efa3
Provides: bundled(golang(github.com/vmware/vmw-guestinfo/message)) = 0.0.0-20220317130741.git510905f0efa3
Provides: bundled(golang(github.com/vmware/vmw-guestinfo/rpcout)) = 0.0.0-20220317130741.git510905f0efa3
Provides: bundled(golang(github.com/vmware/vmw-guestinfo/rpcvmx)) = 0.0.0-20220317130741.git510905f0efa3
Provides: bundled(golang(github.com/vmware/vmw-guestinfo/vmcheck)) = 0.0.0-20220317130741.git510905f0efa3
Provides: bundled(golang(golang.org/x/net/bpf)) = 0.37.0
Provides: bundled(golang(golang.org/x/net/http/httpguts)) = 0.37.0
Provides: bundled(golang(golang.org/x/net/http/httpproxy)) = 0.37.0
Provides: bundled(golang(golang.org/x/net/http2)) = 0.37.0
Provides: bundled(golang(golang.org/x/net/http2/hpack)) = 0.37.0
Provides: bundled(golang(golang.org/x/net/idna)) = 0.37.0
Provides: bundled(golang(golang.org/x/net/internal/httpcommon)) = 0.37.0
Provides: bundled(golang(golang.org/x/net/internal/timeseries)) = 0.37.0
Provides: bundled(golang(golang.org/x/net/trace)) = 0.37.0
Provides: bundled(golang(golang.org/x/oauth2)) = 0.28.0
Provides: bundled(golang(golang.org/x/oauth2/authhandler)) = 0.28.0
Provides: bundled(golang(golang.org/x/oauth2/google)) = 0.28.0
Provides: bundled(golang(golang.org/x/oauth2/google/externalaccount)) = 0.28.0
Provides: bundled(golang(golang.org/x/oauth2/google/internal/externalaccountauthorizeduser)) = 0.28.0
Provides: bundled(golang(golang.org/x/oauth2/google/internal/impersonate)) = 0.28.0
Provides: bundled(golang(golang.org/x/oauth2/google/internal/stsexchange)) = 0.28.0
Provides: bundled(golang(golang.org/x/oauth2/internal)) = 0.28.0
Provides: bundled(golang(golang.org/x/oauth2/jws)) = 0.28.0
Provides: bundled(golang(golang.org/x/oauth2/jwt)) = 0.28.0
Provides: bundled(golang(golang.org/x/sys/cpu)) = 0.31.0
Provides: bundled(golang(golang.org/x/sys/unix)) = 0.31.0
Provides: bundled(golang(golang.org/x/sys/windows)) = 0.31.0
Provides: bundled(golang(golang.org/x/sys/windows/registry)) = 0.31.0
Provides: bundled(golang(google.golang.org/api/googleapi)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/googleapi/transport)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/iamcredentials/v1)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/internal)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/internal/cert)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/internal/gensupport)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/internal/impersonate)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/internal/third_party/uritemplates)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/iterator)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/option)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/option/internaloption)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/storage/v1)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/transport)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/transport/grpc)) = 0.224.0
Provides: bundled(golang(google.golang.org/api/transport/http)) = 0.224.0
Provides: bundled(golang(gopkg.in/yaml.v3)) = 3.0.1

%description
Ignition is a utility used to manipulate systems during the initramfs.  This includes partitioning
disks, formatting partitions, writing files (regular files, systemd units, etc.), and configuring
users. On first boot, Ignition reads its configuration from a source of truth (remote URL, network
metadata service, hypervisor bridge, etc.) and applies the configuration.

%package validate

Summary:  Validation tool for Ignition configs
License:  ASL 2.0

%description validate
Ignition is a utility used to manipulate systems during the initramfs.  This includes partitioning
disks, formatting partitions, writing files (regular files, systemd units, etc.), and configuring
users. On first boot, Ignition reads its configuration from a source of truth (remote URL, network
metadata service, hypervisor bridge, etc.) and applies the configuration.

This package contains a tool for validating Ignition configurations.

%prep
%autosetup -n %{name}-%{version} -p1

%build
export LDFLAGS="-X github.com/coreos/ignition/v2/internal/version.Raw=%{version} "
export LDFLAGS+="-X github.com/coreos/ignition/v2/internal/distro.selinuxRelabel=true "
export LDFLAGS+=' -compressdwarf=false '
export GOFLAGS="-mod=vendor"

%gobuild -o ./ignition internal/main.go

%gobuild -o ./ignition-validate validate/main.go

%install
install -d -p %{buildroot}/%{dracutlibdir}/modules.d
cp -r dracut/* %{buildroot}/%{dracutlibdir}/modules.d/
install -m 0644 -D -t %{buildroot}/%{_unitdir} systemd/ignition-delete-config.service
install -m 0755 -d %{buildroot}/%{_libexecdir}
ln -sf ../lib/dracut/modules.d/30ignition/ignition %{buildroot}/%{_libexecdir}/ignition-apply
ln -sf ../lib/dracut/modules.d/30ignition/ignition %{buildroot}/%{_libexecdir}/ignition-rmcfg

install -p -Dm 0755 ./ignition-validate %{buildroot}%{_bindir}/ignition-validate
install -p -m 0755 ./ignition %{buildroot}/%{dracutlibdir}/modules.d/30ignition

%check
%if %{with check}
%gocheck -t tests
%endif

%files
%license LICENSE
%doc README.md docs/
%{dracutlibdir}/modules.d/*
%{_unitdir}/*.service
%{_libexecdir}/ignition-apply
%{_libexecdir}/ignition-rmcfg

%files validate
%license LICENSE
%doc README.md
%{_bindir}/ignition-validate

%changelog
* Fri Apr 25 2025 wynnfeng <wynnfeng@tencent.com> - 2.21.0-1
- upgrade to 2.21.0 and fix CVE-2025-22868

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.15.0-5
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.15.0-4
- Rebuilt for loongarch release

* Fri Dec 29 2023 jackeyji <jackeyji@tencent.com> - 2.15.0-3
- Rebuilt for golang CVE-2023-39318 and CVE-2023-39319

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.15.0-2
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Jul 10 2023 Shuo Wang <abushwang@tencent.com> - 2.15.0-1
- update to 2.15.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.14.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.14.0-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 22 2023 Shuo Wang <abushwang@tencent.com> - 2.14.0-1
- initial build
